// ESP_Wemos
// attend x seconde , poste en mqtt , deep sleep
// https://github.com/claws/BH1750 lumiere
// https://github.com/wemos/LOLIN_HP303B_Library pression temp
// https://github.com/fu-hsi/pms PMS5003 particules fines
// https://github.com/riverscn/pmsx003.git <==
// https://github.com/wemos/WEMOS_DHT12_Arduino_Library
// https://github.com/wemos/WEMOS_DHT12_Arduino_Library.git
// MQ-07
// https://github.com/tzapu/WiFiManager
// https://github.com/bblanchon/ArduinoJson

// message MQTT
//nom_du_capteur/valeur
// /temperature
// /humidite
// /pression
// /lumiere
// /mq-135/gaz1
// /pm_1
// /pm_2_5
// /pm_10
// /pm_endessous_0_3
// /pm_endessous_0_5
// /pm_endessous_1
// /pm_endessous_2_5
// /pm_endessous_5
// /pm_endessous_10
// ///sons
//
#include <FS.h>
#include <ESP8266WiFi.h>
#include <DNSServer.h>
#include <PubSubClient.h>
#include <ESP8266mDNS.h>

#include <ESP8266WebServer.h>
#include <WiFiManager.h>
#include <ArduinoJson.h>
#include <ArduinoOTA.h>

#include <Wire.h>
#include <WEMOS_SHT3X.h>
#include <LOLIN_HP303B.h>
#include <BH1750.h>
#include <pms.h>
#include <Ticker.h>
Ticker ticker;
Ticker ticker2;
SHT3X sht30(0x45);
BH1750 lightMeter(0x23);
LOLIN_HP303B HP303BPressureSensor = LOLIN_HP303B();
Pmsx003 pms(D4, D3);
int rxPin = D3; // sds011 D1 D2 utilisé par DHT12 i2c
int txPin = D4;
const int GAZ1_A0 = A0;
//#define DEBUG

//// WifiManager_UI variables
char mqtt_server[40]             = "url du serveur.........................";
char mqtt_server_defaut[40]      = "url_serveur";
char mqtt_port[6]                = "1883";
char mqtt_port_defaut[6]         = "1883";
char client_mqtt[20]             = "nom du capteur....";
char client_mqtt_defaut[20]      = "nom_du_capteur";
char user_mqtt[20]               = "utilisateur.......";
char user_mqtt_defaut[20]        = "utilisateur";
char user_pass[20]               = "mot de passe......";
char user_pass_defaut[20]        = "mot_de_passe";
/////////////////////////////////// valeurs du msq MQTT

WiFiClient espClient;
PubSubClient client(espClient);
bool envoie_mqtt = false;
unsigned long lastMsg = 0;
#define MSG_BUFFER_SIZE  (50)
char msg[MSG_BUFFER_SIZE];
int value = 0;

float temps_milli            = 30000;   // temps milli entre 2 mesures
uint64_t minute_dodo       = 10; // min  ESP.deepSleep(1000000 * 60 * (uint64_t)min);

float frequence = 0;  //temps_milli; frequence des mesures, delai
int retour_ok = 0;    // retour du serveur
float temperature = 0;   // temp HP303B
float temperatre = 0; // temp SHT30
float humidite = 0;
float pression = 0;
float lumiere = 0;
float gaz1 = 0;
float pm_1 = 0;
float pm_2_5 = 0;
float pm_10 = 0;
float pm_1_std = 0;
float pm_2_5_std = 0;
float pm_10_std = 0;
float pm_endessous_0_3 = 0;
float pm_endessous_0_5 = 0;
float pm_endessous_1   = 0;
float pm_endessous_2_5 = 0;
float pm_endessous_5   = 0;
float pm_endessous_10  = 0;
auto lastRead = millis();

void tick() {
  //toggle state
  int state = digitalRead(LED_BUILTIN);
  digitalWrite(LED_BUILTIN, !state);
}
void clignotte() {
  int state = digitalRead(LED_BUILTIN);
  digitalWrite(LED_BUILTIN, !state);
  digitalWrite(LED_BUILTIN, state);
  digitalWrite(LED_BUILTIN, !state);
  digitalWrite(LED_BUILTIN, state);
}

void setup() {
  // Connect D0 to RST to wake up
  pinMode(D0, WAKEUP_PULLUP);
  Serial.begin(115200);
  Serial.println("");

  pinMode(LED_BUILTIN, OUTPUT);
  ticker.attach(0.6, tick);
  Serial.println(ESP.getChipId(), HEX);
  sprintf(client_mqtt_defaut, "ESP-%d" , ESP.getChipId() );
  pinMode(GAZ1_A0, INPUT);
  WifiManager_UI();
  ticker.detach();
  ticker.attach(2, tick);
  frequence = minute_dodo;

  Serial.println("");
  //Serial.println(WiFi.ssid);
  Serial.println("IP addresse: ");
  IPAddress IPLOCAL = WiFi.localIP();
  Serial.println("hostname: ");
  Serial.println(WiFi.hostname());
  // mode OTA
  // Port defaults to 8266
  // ArduinoOTA.setPort(8266);
  // Hostname defaults to esp8266-[ChipID]
  // ArduinoOTA.setHostname("myesp8266");
  // No authentication by default
  // ArduinoOTA.setPassword("admin");
  // Password can be set with it's md5 value as well
  // MD5(admin) = 21232f297a57a5a743894a0e4a801fc3
  // ArduinoOTA.setPasswordHash("21232f297a57a5a743894a0e4a801fc3");
  ArduinoOTA.onStart([]() {
    String type;
    if (ArduinoOTA.getCommand() == U_FLASH) {
      type = "sketch";
    } else { // U_FS
      type = "filesystem";
    }
    // NOTE: if updating FS this would be the place to unmount FS using FS.end()
    Serial.println("Start updating " + type);
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) {
      Serial.println("Auth Failed");
    } else if (error == OTA_BEGIN_ERROR) {
      Serial.println("Begin Failed");
    } else if (error == OTA_CONNECT_ERROR) {
      Serial.println("Connect Failed");
    } else if (error == OTA_RECEIVE_ERROR) {
      Serial.println("Receive Failed");
    } else if (error == OTA_END_ERROR) {
      Serial.println("End Failed");
    }
  });
  ArduinoOTA.begin();
  Serial.println("OTA OK");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  /////////////// CAPTEURS ////////////////
  Serial.println();
  Wire.begin();
  delay(200);

  HP303BPressureSensor.begin();
  delay(200);
  // BH1750
  if (!lightMeter.begin(BH1750::ONE_TIME_HIGH_RES_MODE)) Serial.println(F("Error initialising BH1750"));
  //
  delay(200);

  ////SDS010
  /*
    sds.begin();
    Serial.println(sds.queryFirmwareVersion().toString()); // prints firmware version
    Serial.println(sds.setActiveReportingMode().toString()); // ensures sensor is in 'active' reporting mode
    Serial.println(sds.setCustomWorkingPeriod(1).toString()); // sensor sends data every 1 minutes
  */
  //// PMS5003 ////
  pms.begin();
  pms.write(Pmsx003::cmdModeActive);  // par defaut mode passive
  pms.write(Pmsx003::cmdSleep);
  pms.write(Pmsx003::cmdWakeup);
  delay(1000);
}
void publi_mqtt(const char* topic, const char* payload) {
  char buff[100] = "";
  sprintf(buff , "%s%s", client_mqtt, topic);
  client.publish(buff, payload, true);
  Serial.println(buff);
}
void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print(mqtt_server);
    Serial.print(":");
    Serial.print(mqtt_port);
    Serial.print(":");
    Serial.print(client_mqtt);
    Serial.print(":");
    Serial.print(user_mqtt);
    Serial.print(":");
    Serial.print(user_pass);
    Serial.println(":");

    client.setServer(mqtt_server, atoi(mqtt_port));
    //client.setCallback(callback);

    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect(client_mqtt, user_mqtt, user_pass)) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      ///////// MQTT config  ////////////
      if (envoie_mqtt == true) {
        Serial.println("publie");

        publi_mqtt("/frequence", String(frequence).c_str());
        if (temperature > 0) publi_mqtt("/temperature",       String(temperature).c_str());
        if (pression > 0)    publi_mqtt("/pression",          String(pression).c_str());
        if (humidite > 0)    publi_mqtt("/humidite",          String(humidite).c_str());
        if (temperatre > 0)  publi_mqtt("/temp",              String(temperatre).c_str());
        if (lumiere > 0)     publi_mqtt("/lumiere",           String(lumiere).c_str());
        if (gaz1 > 0)        publi_mqtt("/gaz",               String(gaz1).c_str());
        if (pm_1_std > 0)    publi_mqtt("/pm1_std",           String(pm_1_std).c_str());
        if (pm_2_5_std > 0)  publi_mqtt("/pm2_5_std",         String(pm_2_5_std).c_str());
        if (pm_10_std > 0)   publi_mqtt("/pm10_std",          String(pm_10_std).c_str());
        if (pm_1 > 0)        publi_mqtt("/pm1",               String(pm_1).c_str());
        if (pm_2_5 > 0)      publi_mqtt("/pm2_5",             String(pm_2_5).c_str());
        if (pm_10 > 0)       publi_mqtt("/pm10",              String(pm_10).c_str());
        if (pm_endessous_0_3 > 0) publi_mqtt("/pm_endessous_0_3",  String(pm_endessous_0_3).c_str());
        if (pm_endessous_0_5 > 0) publi_mqtt("/pm_endessous_0_5",  String(pm_endessous_0_5).c_str());
        if (pm_endessous_1 > 0)   publi_mqtt("/pm_endessous_1",    String(pm_endessous_1).c_str());
        if (pm_endessous_2_5 > 0) publi_mqtt("/pm_endessous_2_5",  String(pm_endessous_2_5).c_str());
        if (pm_endessous_5 > 0)   publi_mqtt("/pm_endessous_5",    String(pm_endessous_5).c_str());
        if (pm_endessous_10 > 0)  publi_mqtt("/pm_endessous_10",   String(pm_endessous_10).c_str());

        //client.subscribe("inTopic");

        ticker.detach();
        pms.write(Pmsx003::cmdSleep);

        Serial.print("dodo min :");
        Serial.println((float)minute_dodo);
        for (int i = 0; i < 20; i++)
        {
          digitalWrite(BUILTIN_LED, LOW);
          delay(200);
          digitalWrite(BUILTIN_LED, HIGH);
          delay(200);
        }
        // Connect D0 to RST to wake up !
        ESP.deepSleep(minute_dodo * 60 * 1000000);
        delay(25000);
      } else {
        Serial.print("failed, rc=");
        Serial.print(client.state());
      }        
      Serial.println(" retente ");
      delay(60000);
      ESP.restart();
    }
  }
}
void loop() {
  ArduinoOTA.handle();

  envoie_mqtt = false;
  //// BH1750   /////
  uint16_t lux = lightMeter.readLightLevel();
  lumiere  = (float) lux;
  Serial.print("BH1750 Lumiere: ");
  Serial.print(lumiere);
  Serial.println(" lx");
  ////  HP303B  /////
  int16_t oversampling = 7;
  int16_t ret;
  int32_t ret_temperature;
  int32_t ret_pression;
  //ret = HP303BPressureSensor.measureTempOnce(temperature);
  //the commented line below does exactly the same as the one above, but you can also config the precision
  //oversampling can be a value from 0 to 7
  //the HP303B will perform 2^oversampling internal temperature measurements and combine them to one result with higher precision
  //measurements with higher precision take more time, consult datasheet for more information
  ret = HP303BPressureSensor.measureTempOnce(ret_temperature, oversampling);
  if (ret != 0)
  {
    Serial.print("FAIL! ret = ");
    Serial.println(ret);
  }
  else
  {
    Serial.print("HP303B Temperature: ");
    temperature = (float) ret_temperature;
    Serial.print(temperature);
    Serial.println(" degres");
  }
  //Pressure measurement behaves like temperature measurement
  //ret = HP303BPressureSensor.measurePressureOnce(pressure);
  ret = HP303BPressureSensor.measurePressureOnce(ret_pression, oversampling);
  if (ret != 0)
  {
    Serial.print("FAIL! ret = ");
    Serial.println(ret);
  }
  else
  {
    Serial.print("HP303B Pression: ");
    pression = (float) ret_pression / 100;
    Serial.print(pression);
    Serial.println(" millibar");
  }
  //// SHT30 /////
  if (sht30.get() == 0) {
    temperatre = (float)sht30.cTemp;
    humidite   = (float)sht30.humidity;
    Serial.print("SHT30 Temperature       : ");
    Serial.println(temperatre);
    Serial.print("SHT30 Humidite relative : ");
    Serial.println(humidite);
  }
  //// MQ-135 ////
  //Serial.println("attend 30s pour chauffe MQ");
  //Serial.print("GAZ MQ 07        : ");
  //delay(30000);
  gaz1 = (float)analogRead(GAZ1_A0);
  Serial.println(gaz1);

  //// PMS5003 ////
  pms.write(Pmsx003::cmdWakeup);

  float pm_1_tot = 0;
  float pm_2_5_tot = 0;
  float pm_10_tot = 0;
  Serial.print("attend s ");
  Serial.println (temps_milli / 1000);
  delay(temps_milli);

  int bonne_mesure = 0;
  for (bonne_mesure = 0; bonne_mesure <= 4; ) { //fait 5 mesures et prend la moyenne des positifs
    pms.waitForData(Pmsx003::wakeupTime);

    for (int i = 0; i <= 10; i++ ) {
      pm_1_std   = 0;
      pm_2_5_std = 0;
      pm_10_std  = 0;
      pm_1   =  0;
      pm_2_5 =  0;
      pm_10  =  0;
      pm_endessous_0_3 =  0;
      pm_endessous_0_5 =  0;
      pm_endessous_1   = 0;
      pm_endessous_2_5 =  0;
      pm_endessous_5   =  0;
      pm_endessous_10  =  0;

      Serial.println("pms");
      const auto n = Pmsx003::Reserved;
      Pmsx003::pmsData data[n];
      Pmsx003::PmsStatus status = pms.read(data, n);
      switch (status) {
        case Pmsx003::OK:
          {
            Serial.println(bonne_mesure);
            auto newRead = millis();
            lastRead = newRead;
            Serial.println(newRead - lastRead);
            lastRead = newRead;
            // For loop starts from 3
            // Skip the first three data (PM1dot0CF1, PM2dot5CF1, PM10CF1)
            for (size_t i = Pmsx003::PM1dot0; i < n; ++i) {
              Serial.print(data[i]);
              Serial.print("\t");
              Serial.print(Pmsx003::dataNames[i]);
              Serial.print(" [");
              Serial.print(Pmsx003::metrics[i]);
              Serial.print("]");
              Serial.println();
            }
            pm_1_std   = (float)data[3];
            pm_2_5_std = (float)data[4];
            pm_10_std  = (float)data[5];
            pm_1       = (float)data[3];
            pm_2_5     = (float)data[4];
            pm_10      = (float)data[5];
            pm_endessous_0_3 = (float)data[6];
            pm_endessous_0_5 = (float)data[7];
            pm_endessous_1   = (float)data[8];
            pm_endessous_2_5 = (float)data[9];
            pm_endessous_5   = (float)data[10];
            pm_endessous_10  = (float)data[11];
            if ( bonne_mesure++ > 1) {// 2 premieres bonnes mesures non prises en compte
              pm_1_tot   += pm_1;
              pm_2_5_tot += pm_2_5;
              pm_10_tot  += pm_10;
              envoie_mqtt = true;
            }
            break;
          }
        case Pmsx003::noData:
          Serial.println("attend pms");
          break;
        default:
          Serial.println("_________________");
          Serial.println(Pmsx003::errorMsg[status]);
      }
      if (envoie_mqtt) break;
    }
    if (bonne_mesure == 1) delay(4000);
    delay(1000) ;
  }
  // on garde les moyennes des bons apres la premiere mesure
  pm_1   = pm_1_tot   / 3;
  pm_2_5 = pm_2_5_tot / 3;
  pm_10  = pm_10_tot  / 3;

  /*
     // capteur sds011
    PmResult pm = sds.readPm();
    if (pm.isOk()) {
    pm_2_5 = (float)pm.pm25;
    pm_10 = (float)pm.pm10;
    Serial.print("PM2.5             = ");
    Serial.println(pm_2_5);
    Serial.print("PM10              = ");
    Serial.println(pm_10);
    //    Serial.println(pm.toString());
    } else {
    // notice that loop delay is set to 5s (sensor sends data every 3 minutes) and some reads are not available
    //Serial.print("Probleme de lecture SDS011: ");
    //Serial.println(pm.statusToString());
    Serial.print("PM2.5              : ");
    Serial.println(pm_2_5);
    Serial.print("PM10               : ");
    Serial.println(pm_10);
    }
  */
  if (!client.connected()) {
    reconnect();
  }
  client.loop();
}
